Python三 与 C# 面向对象之~分外相关

周日多码文,前几日深夜壹篇,今日再来一篇:

在线编制程序:https://mybinder.org/v2/gh/lotapp/BaseCode/master

在线预览:http://github.lesschina.com/python/base/oop/3.万分相关.html

代码裤子:https://github.com/lotapp/BaseCode/tree/master/python/2.OOP/4.Exception

 

1.异常

1.1 try…except

又到了开新课的时候了,小明同学此番提前预习了文化,乘着老师还没来就在黑板上写下了那段Code:

In [1]:

def main():
    try:
        1 / 0  # ZeroDivisionError: division by zero
    except ZeroDivisionError as ex:
        print(ex)


if __name__ == '__main__':
    main()

 

division by zero

 

1.2 try…except…else…finally

小潘同学刚进去就映入眼帘了,自语道:“try...except破获非常什么人不会?就会如此屁点东西万幸意思秀,切~
笔者给您把 格式补全”

于是乘着小明上洗手间的时候,擦掉小明的Code,本人写了壹段高大上的Code:

In [2]:

# 异常捕获全格式
def test(input_str):
    try:
        eval(input_str)
    except ZeroDivisionError as ex:
        print("except:", ex)
    else:
        print("else:没有异常就奖励100块~")
    finally:
        print("finally:小明是傻子~")


def main():
    test("1/0")
    print("-" * 10)
    test("print('小明啊小明你调坑里了~')")


if __name__ == '__main__':
    main()

 

except: division by zero
finally:小明是傻子~
----------
小明啊小明你调坑里了~
else:没有异常就奖励100块~
finally:小明是傻子~

 

那会儿小明和教育工作者共同进入了,同学们隐隐间都听到小明的自夸声:“老师,笔者可好了,提前预习并且还写了个demo在黑板上呢~”

师资1进门望着黑板就笑了,同学们也笑成一片。小明心想,咦~难道笔者写错了?定眼1看黑板,气呼呼的回座位了

else能够不写,可是大家
基本上还是会写的,究竟能够清楚是当真没有不当,而不是遮挡了错误

1.叁 八个非常处理

导师很安心,感到这么些班真风趣,大家学习空前热情,为了照看小明,老师反问道:“有何人知道
两个可怜怎么处理?”

小明火速的举手并把黑板上内容擦完,写下了之类代码:

In [3]:

# 多个异常捕获
def main():
    try:
        print(xiaopan)  # NameError: name 'xiaopan' is not defined
        1 / 0  # ZeroDivisionError: division by zero
    except NameError as ex:
        print(ex)
    except ZeroDivisionError as ex:
        print(ex)

if __name__ == '__main__':
    main()

 

name 'xiaopan' is not defined

 

先生问了小圣元声,有多少个出口?

小明骄傲的说道:“五个,我写了七个可怜处理,当然都奉行了”

同学们又笑了,小潘捉弄的说了句:“1看就精通2018年C#没好好学,那不都平等嘛,相见特别下边代码还施行呢?用血汗好好思量”

当我们感觉某个代码也许会出错开上下班时间,就能够用try来运维那段代码,假若实践出错,则三番五次代码不会继续实施,而是径直跳转至except语句块,执行完except后,如果有finally语句块,则执行finally语句块

小明又狼狈了。。。

一.4 多可怜简写

名师再一次帮小明圆了个场:“已经很不轻便了,便是最后小得意的时候口误了,那小明同学你驾驭Python里面多可怜有个方便写法吗?”

小明赶紧拿起粉笔刷刷刷的写完,然后说道:“of course

In [4]:

# 多个异常捕获的简写(注意哦,是元组哦)
def main():
    try:
        print(xiaopan)  # NameError: name 'xiaopan' is not defined
        1 / 0  # ZeroDivisionError: division by zero
    except (NameError, ZeroDivisionError) as ex:
        print(ex)


if __name__ == '__main__':
    main()

 

name 'xiaopan' is not defined

 

教师赶紧夸了夸小明,心想,哎呦喂终于把那难缠的钱物弄回座位了。

小明走前还不忘说一句:“简写的时候注意格式哦,是 元组 不是逗号分隔”

教授这堂课很自在,我们都预习了同时内容也相比较轻便。

随着以咨询的方法问道:“小潘同学,你理解非凡的基类是怎么样吧?尽管要捕获全体尤其该如何是好啊?”

小潘站起来说道:“是BaseException

师资扩大道:“全数的荒唐类型都卫冕自BaseException,所以在动用except时索要留意的是,它不仅捕获该品种的不当,还把其子类也共同抓获了”

从而1般在捕获极度的时候 把子类至极放在前面,父类放在前边

看如下代码:

In [5]:

def main():
    try:
        1 / 0  # ZeroDivisionError: division by zero
    except BaseException as ex:
        print("base:", ex)
    except ZeroDivisionError as ex:
        print(ex)


if __name__ == '__main__':
    main()

 

base: division by zero

 

比方把父类放第一个,那么ZeroDivisionError千古也不会被施行了,其实你只要装了
代码规范提示插件会提醒您的

能够参见小编事先写的
vscode设置python三调节和测试环境的增加多数

来个通用至极捕获的简写(官方不引入应用简写):

In [6]:

# 直接except就行了
def main():
    try:
        1 / 0
        dnt += 1
    except:
        print("屏蔽错误")


if __name__ == '__main__':
    main()

 

屏蔽错误

 

老师继续讲到,大家来看二个气象,现在广大在线编辑器,你在她们那多少个编辑框里写下了代码也是有丰硕抛出的,这是怎么处理的吧?

微软有开源代码编辑器比较受欢迎(VSCode的一有的):monaco-editor

晋升一下,假若真的要做在线编辑器,记得思索一下fork炸弹,那几个实在也是很老的事物了,程序员基本上都应当接触过了

壹.伍 抛出十分

大家继续,像C#是用thorw抛出分外,那Python怎么 捕获异常后再抛出
呢?怎么自定义异常 呢?

承接往下看:

In [7]:

# 捕获异常后再丢出,eg:在线运行的用户Code
def main():
    try:
        1 / 0  # ZeroDivisionError: division by zero
    except ZeroDivisionError as ex:
        print(ex)  # 写个日志,回头出问题可以深究
        raise


if __name__ == '__main__':
    main()

 

division by zero

 

---------------------------------------------------------------------------
ZeroDivisionError                         Traceback (most recent call last)
<ipython-input-7-15f01346e2d8> in <module>()
      9 
     10 if __name__ == '__main__':
---> 11main()

<ipython-input-7-15f01346e2d8> in main()
      2 def main():
      3     try:
----> 41 / 0  # ZeroDivisionError: division by zero
      5     except ZeroDivisionError as ex:
      6         print(ex)  # 写个日志,回头出问题可以深究

ZeroDivisionError: division by zero

In [8]:

# 抛出自定义异常
class DntException(BaseException):
    pass


def get_age(num):
    if num <= 0:
        raise DntException("num must>0")
    else:
        print(num)


def main():
    get_age(-1)
    get_age(22)  # 程序崩了,这句话不会被执行了


if __name__ == '__main__':
    main()

 

---------------------------------------------------------------------------
DntException                              Traceback (most recent call last)
<ipython-input-8-7c9dec6ec225> in <module>()
     17 
     18 if __name__ == '__main__':
---> 19main()

<ipython-input-8-7c9dec6ec225> in main()
     12 
     13 def main():
---> 14get_age(-1)
     15     get_age(22)  # 程序崩了,这句话不会被执行了
     16 

<ipython-input-8-7c9dec6ec225> in get_age(num)
      6 def get_age(num):
      7     if num <= 0:
----> 8raise DntException("num must>0")
      9     else:
     10         print(num)

DntException: num must>0

 

卓殊那壹块大致讲完了(logging模块前面会说)有何样补充的能够说的^_^

 

1.6 C#异常

小明又拓展了C#的代码转变,怎么看都是为依然C#简易啊,根本不用说吗,代码1贴就秒懂了。。。

In [1]:

%%script csharp
try
{
    Convert.ToInt32("mmd");
}
catch (Exception ex)
{
    // Input string was not in a correct format
    Console.WriteLine(ex.Message);
}

 

Input string was not in a correct format.

In [2]:

%%script csharp
//抛出自定义异常
try
{
    throw new Exception("出错了啊");
}
catch (Exception ex)
{
    Console.WriteLine(ex.Message);
}

 

出错了啊

 

您能够自定义分外类,承继Exception就可以,对了C#个中也是有finally的

try
{
    throw new Exception("出错了啊");
    //Convert.ToInt32("mmd");
}
catch (Exception ex)
{
    // Input string was not in a correct format
    Console.WriteLine(ex.Message);
}
finally
{
    Console.WriteLine("finally");
}

当今有的亟需finally的地点诸多都被using(){}接管了,所以一定情景会选拔

先那样了

相关文章